//go:build !disable_pgv
// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/config/cluster/redis/redis_cluster.proto

package redis

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on RedisClusterConfig with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *RedisClusterConfig) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on RedisClusterConfig with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// RedisClusterConfigMultiError, or nil if none found.
func (m *RedisClusterConfig) ValidateAll() error {
	return m.validate(true)
}

func (m *RedisClusterConfig) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if d := m.GetClusterRefreshRate(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			err = RedisClusterConfigValidationError{
				field:  "ClusterRefreshRate",
				reason: "value is not a valid duration",
				cause:  err,
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		} else {

			gt := time.Duration(0*time.Second + 0*time.Nanosecond)

			if dur <= gt {
				err := RedisClusterConfigValidationError{
					field:  "ClusterRefreshRate",
					reason: "value must be greater than 0s",
				}
				if !all {
					return err
				}
				errors = append(errors, err)
			}

		}
	}

	if d := m.GetClusterRefreshTimeout(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			err = RedisClusterConfigValidationError{
				field:  "ClusterRefreshTimeout",
				reason: "value is not a valid duration",
				cause:  err,
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		} else {

			gt := time.Duration(0*time.Second + 0*time.Nanosecond)

			if dur <= gt {
				err := RedisClusterConfigValidationError{
					field:  "ClusterRefreshTimeout",
					reason: "value must be greater than 0s",
				}
				if !all {
					return err
				}
				errors = append(errors, err)
			}

		}
	}

	if all {
		switch v := interface{}(m.GetRedirectRefreshInterval()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, RedisClusterConfigValidationError{
					field:  "RedirectRefreshInterval",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, RedisClusterConfigValidationError{
					field:  "RedirectRefreshInterval",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetRedirectRefreshInterval()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return RedisClusterConfigValidationError{
				field:  "RedirectRefreshInterval",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if all {
		switch v := interface{}(m.GetRedirectRefreshThreshold()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, RedisClusterConfigValidationError{
					field:  "RedirectRefreshThreshold",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, RedisClusterConfigValidationError{
					field:  "RedirectRefreshThreshold",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetRedirectRefreshThreshold()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return RedisClusterConfigValidationError{
				field:  "RedirectRefreshThreshold",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	// no validation rules for FailureRefreshThreshold

	// no validation rules for HostDegradedRefreshThreshold

	if len(errors) > 0 {
		return RedisClusterConfigMultiError(errors)
	}

	return nil
}

// RedisClusterConfigMultiError is an error wrapping multiple validation errors
// returned by RedisClusterConfig.ValidateAll() if the designated constraints
// aren't met.
type RedisClusterConfigMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m RedisClusterConfigMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m RedisClusterConfigMultiError) AllErrors() []error { return m }

// RedisClusterConfigValidationError is the validation error returned by
// RedisClusterConfig.Validate if the designated constraints aren't met.
type RedisClusterConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e RedisClusterConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e RedisClusterConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e RedisClusterConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e RedisClusterConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e RedisClusterConfigValidationError) ErrorName() string {
	return "RedisClusterConfigValidationError"
}

// Error satisfies the builtin error interface
func (e RedisClusterConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sRedisClusterConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = RedisClusterConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = RedisClusterConfigValidationError{}
